Index: /documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 27117)
+++ /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 27118)
@@ -2829,5 +2829,5 @@
 <Prerequisite id="multimedia_collection_explore"/>
 <SampleFiles folder="beatles"/>
-<Version initial="2.60" current="2.85"/>
+<Version initial="2.60" current="2.85|3.05"/>
 <Content>
 <Comment>
@@ -2957,5 +2957,6 @@
     <Tab n="2"/>&lt;/gsf:when&gt;<br />
     <Tab n="2"/>&lt;gsf:when test='equals' test-value='Supplementary'&gt;<br />
-      <Tab n="3"/>&lt;gsf:link type=&quot;source&quot;&gt;&lt;gsf:metadata name=&quot;srcicon&quot;/&gt;&lt;/gsf:link&gt; &lt;gsf:link type=&quot;document&quot;&gt;&lt;gsf:icon type=&quot;document&quot;/&gt;&lt;/gsf:link&gt;<br />
+      <Tab n="3"/>&lt;gsf:link type=&quot;source&quot;&gt;&lt;gsf:metadata name=&quot;srcicon&quot;/&gt;&lt;/gsf:link&gt;<br />
+	  <Tab n="3" />&lt;gsf:link type=&quot;document&quot;&gt;&lt;gsf:icon type=&quot;document&quot;/&gt;&lt;/gsf:link&gt;<br />
     <Tab n="2"/>&lt;/gsf:when&gt;<br />
     <Tab n="2"/>&lt;gsf:otherwise&gt;<br />
@@ -3015,5 +3016,5 @@
 </Heading>
 <NumberedItem>
-<Text id="0597">There are sometimes several documents with the same title. For example, <AutoText text="All My Loving" type="italics"/> appears both as lyrics and tablature (under <AutoText text="ALL MY LOVING" type="italics"/>). The <AutoText key="coredm::_Global:labelTitle_"/> browser might be improved by grouping these together under a bookshelf icon. This is a job for an <AutoText text="AZCompactList"/>. In the previous tutorial we showed how to use the <AutoText text="bookshelf_type"/> option in <AutoText text="List"/> classifier to group documents with the same metadata value (<AutoText key="metadata::dc.Format"/> in that case) in one bookshelf. Here we use <AutoText text="AZCompactList"/> instead.</Text>
+<Text id="0597">There are sometimes several documents with the same title. For example, <AutoText text="All My Loving" type="italics"/> appears both as lyrics and tablature (under <AutoText text="ALL MY LOVING" type="italics"/>). The <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> browser might be improved by grouping these together under a bookshelf icon. This is a job for an <AutoText text="AZCompactList"/>. In the previous tutorial we showed how to use the <AutoText text="bookshelf_type"/> option in <AutoText text="List"/> classifier to group documents with the same metadata value (<AutoText key="metadata::dc.Format"/> in that case) in one bookshelf. Here we use <AutoText text="AZCompactList"/> instead.</Text>
 <BulletList>
 <Bullet>
@@ -3056,25 +3057,14 @@
 </MajorVersion>
 <MajorVersion number="3">
-<Text id="0606-3">Make the bookshelves show how many documents they contain by modifying the <AutoText text="VList classifierNode"/> template of the <AutoText text="browse"/> format feature in the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel. Remove the portion highlighted below:</Text> 
-<Format>
-      <Tab n="1"/>...<br />
-      <Tab n="1"/>&lt;xsl:call-template name=&quot;choose-title&quot;/&gt;<br />
-      <Tab n="1"/><highlight>&lt;gsf:switch&gt;<br />
-        <Tab n="2"/>&lt;gsf:metadata name=&quot;Source&quot;/&gt;<br />
-        <Tab n="2"/>&lt;gsf:when test=&quot;exists&quot;&gt;<br />
-          <Tab n="3"/>&lt;br/&gt;<br />
-          <Tab n="3"/>&lt;i&gt;(&lt;gsf:metadata name=&quot;Source&quot;/&gt;)&lt;/i&gt;<br />
-        <Tab n="2"/>&lt;/gsf:when&gt;<br />
-      <Tab n="1"/>&lt;/gsf:switch&gt;<br />
-    &lt;/td&gt;</highlight>
-</Format>
-And replace it with the statements highlighted here:
-<Format>
-      <Tab n="1"/>...<br />
-      <Tab n="1"/>&lt;xsl:call-template name=&quot;choose-title&quot;/&gt;<br />
-    <highlight>&lt;/td&gt;<br />
-    &lt;td&gt;<br />
+<Text id="0606-3">Make the bookshelves show how many documents they contain by modifying the <AutoText text="VList classifierNode"/> template of the <AutoText text="browse"/> format feature in the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel. Insert the highlighted statements:</Text> 
+<Format>
+      <Tab n="1"/>&lt;gsf:template match=&quot;classifierNode[@classifierStyle = 'VList']&quot;&gt;<br />
+	  <Tab n="1"/>...<br />
+      <Tab n="1"/>&lt;gsf:metadata name=&quot;Title&quot;/&gt;<br />
+	 &lt;/td&gt;<br />
+    <highlight>&lt;td&gt;<br />
        <Tab n="1"/>(&lt;gsf:metadata name=&quot;numleafdocs&quot;/&gt;)<br />
     &lt;/td&gt;</highlight>
+	&lt;gsf:template<br />
 </Format>
 <Text id="0606-3a">The complete format statement for the <AutoText text="VList classifierNode"/> template of the <AutoText text="browse"/> format feature can be copied from <Path>sample_files &rarr; beatles &rarr; format_tweaks &rarr; show_num_docs_3.txt</Path>.</Text>
@@ -3087,5 +3077,5 @@
 <NumberedItem>
 <Text id="0612">In the <AutoText key="glidict::CDM.GUI.Classifiers"/> section on the <AutoText key="glidict::GUI.Design"/> panel, add a <AutoText text="Phind"/> classifier. Leave the settings at their defaults: this generates a phrase browsing classifier that sources its phrases from <i>Title</i> and <i>text</i>.</Text>
-<Text id="0612b"><b>Build</b> the collection again and <b>preview</b> it. Select the new <AutoText key="coredm::_Global:labelPhrase_"/> option from the navigation bar. Enter a single word in the text box, such as <AutoText text="band" type="quotes"/>. The phrase browser will present you with phrases found in the collection containing the search term. This can provide a useful way of browsing a very large collection. Note that even though it is called a phrase browser, only single terms can be used as the starting point for browsing.</Text>
+<Text id="0612b"><b>Build</b> the collection again and <b>preview</b> it. Select the new <MajorVersion number="2"><AutoText key="coredm::_Global:labelPhrase_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::PhindPhraseBrowse::PhindApplet.name" /></MajorVersion> option from the navigation bar. Enter a single word in the text box, such as <AutoText text="band" type="quotes"/>. The phrase browser will present you with phrases found in the collection containing the search term. This can provide a useful way of browsing a very large collection. Note that even though it is called a phrase browser, only single terms can be used as the starting point for browsing.</Text>
 </NumberedItem>
 <Heading>
@@ -3131,5 +3121,5 @@
 </Heading>
 <Comment>
-<Text id="0618a">We now clean up the <AutoText key="coredm::_Global:labelTitle_"/> browser.</Text>
+<Text id="0618a">We now clean up the <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> browser.</Text>
 </Comment>
 <NumberedItem>
@@ -3147,5 +3137,5 @@
 </NumberedItem>
 <Comment>
-<Text id="0640">One powerful use of regular expressions in the exercise was to clean up the <AutoText key="coredm::_Global:labelTitle_"/> browser. Perhaps the best way of doing this would be to have proper title metadata. The metadata extracted from HTML files is messy and inconsistent, and this was reflected in the original <AutoText key="coredm::_Global:labelTitle_" type="italics"/> browser. Defining proper title metadata would be simple but rather laborious. Instead, we have opted to use regular expressions in the <AutoText text="AZCompactList"/> classifier to clean up the title metadata. This is difficult to understand, and a bit fiddly to do, but if you can cope with its idiosyncrasies it provides a quick way to clean up the extracted metadata and avoid having to enter a large amount of metadata.</Text>
+<Text id="0640">One powerful use of regular expressions in the exercise was to clean up the <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> browser. Perhaps the best way of doing this would be to have proper title metadata. The metadata extracted from HTML files is messy and inconsistent, and this was reflected in the original <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> browser. Defining proper title metadata would be simple but rather laborious. Instead, we have opted to use regular expressions in the <AutoText text="AZCompactList"/> classifier to clean up the title metadata. This is difficult to understand, and a bit fiddly to do, but if you can cope with its idiosyncrasies it provides a quick way to clean up the extracted metadata and avoid having to enter a large amount of metadata.</Text>
 </Comment>
 <Heading>
@@ -3165,5 +3155,5 @@
 <NumberedItem>
 <Text id="0645a">Open up another file browser, and locate the small beatles collection in your Greenstone installation:</Text>
-<Path>Greenstone &rarr; collect &rarr; smallbea</Path>
+<Path>Greenstone<MajorVersion number="3">3 &rarr; web &rarr; sites &rarr; localsite </MajorVersion> &rarr; collect &rarr; smallbea</Path>
 <Text id="0645b"><AutoText text="smallbea"/> is the folder name generated by Greenstone for this collection. You can determine what the folder name is for a collection by looking at the title bar of the Librarian Interface: the folder name is displayed in brackets after the collection name.</Text>
 </NumberedItem>
@@ -3185,5 +3175,5 @@
 </MajorVersion>
 <NumberedItem>
-<Text id="0648">Re-edit <MajorVersion number="2"><AutoText text="VList" /> your format statement</MajorVersion><MajorVersion number="3">the previously edited portion of the <AutoText text="documentNode"/> format statement of the <AutoText text="browse"/> format feature</MajorVersion> (in <AutoText key="glidict::CDM.GUI.Formats"/> on the <AutoText key="glidict::GUI.Format"/> panel) to be the following. You can copy this text from the file <Path>sample_files &rarr; beatles &rarr; format_tweaks &rarr; multi_icons<MajorVersion number="3">_3</MajorVersion>.txt</Path>.</Text>
+<Text id="0648">Re-edit <MajorVersion number="2"><AutoText text="VList" /> your format statement</MajorVersion><MajorVersion number="3">the previously edited portion of the <AutoText text="documentNode"/> format statement of the <AutoText text="browse"/> format feature</MajorVersion> (in <AutoText key="glidict::CDM.GUI.Formats"/> on the <AutoText key="glidict::GUI.Format"/> panel) to be the following. You can copy this text from the file <Path>sample_files &rarr; beatles &rarr; format_tweaks &rarr; multi_icons<MajorVersion number="3">_3</MajorVersion>.txt</Path>.<MajorVersion number="3">Change: </MajorVersion></Text>
 <Format>
 <MajorVersion number="2">
@@ -3208,6 +3198,28 @@
 </MajorVersion>
 <MajorVersion number="3">
+&lt;td valign=&quot;top&quot;&gt;<br />
+  <Tab n="1"/><highlight>&lt;gsf:switch&gt;<br />
+    <Tab n="2"/>&lt;gsf:metadata name=&quot;dc.Format&quot;/&gt;<br />
+    <Tab n="2"/>&lt;gsf:when test='equals' test-value='Audio'&gt;<br />
+      <Tab n="3"/>&lt;gsf:link type=&quot;source&quot;&gt;&lt;gsf:metadata name=&quot;srcicon&quot;/&gt;&lt;/gsf:link&gt;<br />
+    <Tab n="2"/>&lt;/gsf:when&gt;<br />
+    <Tab n="2"/>&lt;gsf:when test='equals' test-value='Images'&gt;<br />
+      <Tab n="3"/>&lt;gsf:link type=&quot;source&quot;&gt;&lt;gsf:metadata name=&quot;thumbicon&quot;/&gt;&lt;/gsf:link&gt;<br />
+    <Tab n="2"/>&lt;/gsf:when&gt;<br />
+    <Tab n="2"/>&lt;gsf:when test='equals' test-value='Supplementary'&gt;<br />
+      <Tab n="3"/>&lt;gsf:link type=&quot;source&quot;&gt;&lt;gsf:metadata name=&quot;srcicon&quot;/&gt;&lt;/gsf:link&gt; &lt;gsf:link type=&quot;document&quot;&gt;&lt;gsf:icon type=&quot;document&quot;/&gt;&lt;/gsf:link&gt;<br />
+    <Tab n="2"/>&lt;/gsf:when&gt;<br />
+    <Tab n="2"/>&lt;gsf:otherwise&gt;<br />
+      <Tab n="3"/>&lt;gsf:link type=&quot;document&quot;&gt;&lt;gsf:icon type=&quot;document&quot;/&gt;&lt;/gsf:link&gt;<br />
+    <Tab n="2"/>&lt;/gsf:otherwise&gt;<br />
+  <Tab n="1"/>&lt;/gsf:switch&gt;</highlight><br />
+&lt;/td&gt;
+</MajorVersion>
+</Format>
+<MajorVersion number="3">
+<Text id="0648a">to this:</Text>
+<Format>
   &lt;td valign=&quot;top&quot;&gt;<br />
-     <Tab n="1"/>&lt;gsf:switch&gt;<br />
+     <highlight><Tab n="1"/>&lt;gsf:switch&gt;<br />
         <Tab n="2"/>&lt;gsf:metadata name=&quot;dc.Format&quot;/&gt;<br />
 	<Tab n="2"/>&lt;gsf:when test=&quot;equals&quot; test-value=&quot;Lyrics&quot;&gt;<br />
@@ -3254,8 +3266,8 @@
           <Tab n="3"/>&lt;/gsf:link&gt;<br />
         <Tab n="2"/>&lt;/gsf:when&gt;<br />
-      <Tab n="1"/>&lt;/gsf:switch&gt;<br />
+      <Tab n="1"/>&lt;/gsf:switch&gt;<br /></highlight>
     &lt;/td&gt;
-</MajorVersion>
-</Format> 
+	</Format>
+</MajorVersion> 
 </NumberedItem>
 <NumberedItem>
@@ -3324,5 +3336,5 @@
 </Title>
 <SampleFiles folder="niupepa"/>
-<Version initial="2.60" current="2.85"/>
+<Version initial="2.60" current="2.85|3.05"/>
 <Content>
 <Comment>
@@ -3342,5 +3354,5 @@
 </Comment>
 <NumberedItem>
-<Text id="0681">Go to the <AutoText key="glidict::GUI.Create"/> panel, <b>build</b> the collection and <b>preview</b> the result. Search for <AutoText text="waka" type="quoted"/> and view one of the titles listed (all three appear as <AutoText text="Te Whetu o Te Tau" type="italics"/>). Browse by <AutoText key="coredm::_Global:labelTitle_"/> and view one of the <AutoText text="Te Waka o Te Iwi" type="italics"/> newspapers. Note that only the <AutoText text="Te Whetu o Te Tau" type="italics"/> newspapers have text; <AutoText text="Te Waka o Te Iwi" type="italics"/> papers don't.</Text>
+<Text id="0681">Go to the <AutoText key="glidict::GUI.Create"/> panel, <b>build</b> the collection and <b>preview</b> the result. Search for <AutoText text="waka" type="quoted"/> and view one of the titles listed (all three appear as <AutoText text="Te Whetu o Te Tau" type="italics"/>). Browse by <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> and view one of the <AutoText text="Te Waka o Te Iwi" type="italics"/> newspapers. Note that only the <AutoText text="Te Whetu o Te Tau" type="italics"/> newspapers have text; <AutoText text="Te Waka o Te Iwi" type="italics"/> papers don't.</Text>
 </NumberedItem>
 <Comment>
@@ -3351,5 +3363,5 @@
 </Heading>
 <Comment>
-<Text id="0684">Under <AutoText key="coredm::_Global:labelTitle_"/>, documents from the same series are repeated without any distinguishing features such as date, volume or number. It would be better to group them by series title and display other information within each group. This can be accomplished using the <AutoText text="-bookshelf_type"/> option to the <AutoText text="List"/> classifier, and tuning the classifier's format statement.</Text>
+<Text id="0684">Under <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion>, documents from the same series are repeated without any distinguishing features such as date, volume or number. It would be better to group them by series title and display other information within each group. This can be accomplished using the <AutoText text="-bookshelf_type"/> option to the <AutoText text="List"/> classifier, and tuning the classifier's format statement.</Text>
 </Comment>
 <NumberedItem>
@@ -3360,10 +3372,10 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0686a"><b>Build</b> the collection, and <b>preview</b> the <AutoText key="coredm::_Global:labelTitle_" type="italics"/> list.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="0687">Now we change the format statement for <AutoText key="coredm::_Global:labelTitle_" type="italics"/> to display more information about the documents. In the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel, select the <AutoText text="dc.Title;ex.Title"/> classifier (CL1) in the <AutoText key="glidict::CDM.FormatManager.Feature"/> list<MajorVersion number="2">, and <AutoText text="VList"/> in the <AutoText key="glidict::CDM.FormatManager.Part"/> list.</MajorVersion> Click <AutoText key="glidict::CDM.FormatManager.Add" type="button"/> to add this format statement to your collection. 
+<Text id="0686a"><b>Build</b> the collection, and <b>preview</b> the <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> list.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="0687">Now we change the format statement for <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> to display more information about the documents. In the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel, select the <AutoText text="dc.Title;ex.Title"/> classifier (CL1) in the <AutoText key="glidict::CDM.FormatManager.Feature"/> list.<MajorVersion number="2">, and <AutoText text="VList"/> in the <AutoText key="glidict::CDM.FormatManager.Part"/> list.</MajorVersion> Click <AutoText key="glidict::CDM.FormatManager.Add" type="button"/> to add this format statement to your collection. 
 <MajorVersion number="2">Delete the contents of the <AutoText key="glidict::CDM.FormatManager.Editor"/> box, and add the following text. (This format statement can be copied and pasted from the file <Path>sample_files &rarr; niupepa &rarr; formats &rarr; titles_tweak.txt</Path>.)</MajorVersion>
-<MajorVersion number="3">Edit the contents of the <AutoText text="browse"/> format statement by removing the following in the <AutoText text="documentNode"/> template:</MajorVersion>
+<MajorVersion number="3">Edit the contents of the <AutoText text="dc.Title;ex.Title"/> classifier format statement by removing the following in the <AutoText text="documentNode"/> template:</MajorVersion>
 </Text>
 <MajorVersion number="2">
@@ -3404,5 +3416,5 @@
 <Format>
   &lt;td valign=&quot;top&quot;&gt;<br />
-    <Tab n="1"/>Volume:&lt;gsf:metadata name=&quot;Volume&quot;/&gt; Number:&lt;gsf:metadata name=&quot;Number&quot;/&gt; Date:&lt;gsf:metadata format=&quot;formatDate&quot; name=&quot;Date&quot;/&gt;<br />
+    <Tab n="1"/>Volume: &lt;gsf:metadata name=&quot;Volume&quot;/&gt; Number: &lt;gsf:metadata name=&quot;Number&quot;/&gt; Date: &lt;gsf:metadata format=&quot;formatDate&quot; name=&quot;Date&quot;/&gt;<br />
   &lt;/td&gt;<br />
 </Format>
@@ -3416,5 +3428,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0690a">Refresh in the web browser to view the new <AutoText key="coredm::_Global:labelTitle_" type="italics"/> list.</Text>
+<Text id="0690a">Refresh in the web browser to view the new <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion> list.</Text>
 <Text id="0687c">As a consequence of using the <AutoText text="bookshelf_type"/> option of the <AutoText text="List"/> classifier, bookshelf icons appear when titles are browsed. This revised format statement has the effect of specifying in brackets how many items are contained within a bookshelf<MajorVersion number="3">, for classifier nodes</MajorVersion>. <MajorVersion number="2">It works by exploiting the fact that only bookshelf icons define <Format>[numleafdocs]</Format> metadata.</MajorVersion> For document nodes, Title is not displayed. Instead, Volume, Number and Date information are displayed.</Text>
 </NumberedItem>
@@ -3427,9 +3439,19 @@
 <MajorVersion number="3">
 <NumberedItem>
-<Text id="0686b-3">In the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel, select <AutoText text="DateList" /> in the <AutoText key="glidict::CDM.FormatManager.Feature"/> list, and click <AutoText key="glidict::CDM.FormatManager.Add" type="button"/> to add this format statement to your collection. Replace the final <Format>&lt;td&gt;</Format> table cell element of the new <AutoText text="DateList"/>'s <AutoText text="VList classifierNode"/> template with:</Text>
-<Format>
+<Text id="0686b-3">In the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel, select <AutoText text="DateList" /> in the <AutoText key="glidict::CDM.FormatManager.Feature"/> list, and click <AutoText key="glidict::CDM.FormatManager.Add" type="button"/> to add this format statement to your collection. In the <AutoText text="documentNode"/> template of the new <AutoText text="DateList"/> feature, replace:</Text>
+<Format>
+	&lt;gsf:switch&gt;<br />
+    <Tab n="1"/>&lt;gsf:metadata name=&quot;Source&quot;/&gt;<br />
+	<Tab n="1"/>&lt;gsf:when test=&quot;exists&quot;/&gt;<br />
+	<Tab n="2"/>&lt;br/&gt;<br />
+	<Tab n="2"/>&lt;i&gt;(&lt;gsf:metadata name=&quot;Source&quot;&gt;)&lt;/i&gt;<br />
+	<Tab n="1"/>&lt;/gsf:when&gt;<br />
+	&lt;/gsf:switch&gt;
+</Format>
+<Text id="0686b-31a">with this:</Text>
+<Format>
+  &lt;/td&gt;<br />
   &lt;td valign=&quot;top&quot;&gt;<br />
     <Tab n="1"/>&lt;xsl:call-template name=&quot;choose-date&quot;/&gt;<br />
-  &lt;/td&gt;
 </Format>
 </NumberedItem>
@@ -3450,8 +3472,10 @@
 </MajorVersion>
 <NumberedItem>
-<Text id="0686b"><b>Build</b> the collection, and <b>preview</b> the <AutoText key="coredm::_Global:labelDate_" type="italics"/> list.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="0691">The <AutoText key="coredm::_Global:labelDate_" type="italics"/> list groups documents by date. Greenstone's internal date format is YYYYMMDD, for example 18580601, and this is crucial for the <AutoText text="DateList" /> classifier to correctly parse date metadata and generate an ordered date list. However, the date has been made to look nice by adding a <MajorVersion number="2"><AutoText text="[format:]"/> macro</MajorVersion><MajorVersion number="3">&quot;<AutoText text="format=formatDate"/>&quot; attribute</MajorVersion> to Date metadata in the format statement.</Text>
+<Text id="0686b"><b>Build</b> the collection, and <b>preview</b> the <MajorVersion number="2"><AutoText key="coredm::_Global:labelDate_" type="italics"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Date.buttonname"/>
+</MajorVersion> list.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="0691">The <MajorVersion number="2"><AutoText key="coredm::_Global:labelDate_" type="italics"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Date.buttonname"/>
+</MajorVersion> list groups documents by date. Greenstone's internal date format is YYYYMMDD, for example 18580601, and this is crucial for the <AutoText text="DateList" /> classifier to correctly parse date metadata and generate an ordered date list. However, the date has been made to look nice by adding a <MajorVersion number="2"><AutoText text="[format:]"/> macro</MajorVersion><MajorVersion number="3">&quot;<AutoText text="format=formatDate"/>&quot; attribute</MajorVersion> to Date metadata in the format statement.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3479,5 +3503,6 @@
 </Format>
 </MajorVersion>
-<Text id="0691c">Refresh in the web browser to view the new <AutoText key="coredm::_Global:labelDate_" type="italics"/> list. The dates are now shown in internal format. </Text>
+<Text id="0691c">Refresh in the web browser to view the new <MajorVersion number="2"><AutoText key="coredm::_Global:labelDate_" type="italics"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Date.buttonname"/>
+</MajorVersion> list. The dates are now shown in internal format. </Text>
 </NumberedItem>
 <NumberedItem>
@@ -3651,5 +3676,5 @@
 <SampleFiles folder="niupepa"/>
 <Prerequisite id="scanned_image_collection"/>
-<Version initial="2.70" current="2.85"/>
+<Version initial="2.70" current="2.85|3.05"/>
 <Content>
 <Comment>
@@ -3692,8 +3717,8 @@
 1:images/12_3_6_1.gif:text/12_3_6_1.txt
 </Format>
-<Text id="sc16">Note that if there is no text file, you can leave that space blank. You need to add a line for each page in the document. Make sure you increment the page number as well as the image number for each line.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="sc17">Save the file using <b>Filename</b> <AutoText text="12_3_6.item" type="italics"/>, and save as a plain text document. (If you are using Windows, make sure the file doesn't accidentally end up getting saved as <AutoText text="12_3_6.item.txt" type="italics"/>.) Back in the <AutoText key="glidict::GUI.Gather"/> panel of the Librarian Interface, locate the new file in the <b>Workspace</b> tree, and drag it into the collection, adding it to the <AutoText text="12"/> folder.</Text>
+<Text id="sc16">Note that if there is no text file, you can leave that space blank. You need to add a line for each page in the document. Make sure you increment the page number as well as the image number for each line. (The full text for this file can be copied from <Path>sample_files &rarr; niupepa &rarr; formats &rarr; 12item_text.txt</Path>.)</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="sc17">Save the file using <b>Filename </b> <AutoText text="12_3_6.item" type="italics"/>, and save as a plain text document. (If you are using Windows, make sure the file doesn't accidentally end up getting saved as <AutoText text="12_3_6.item.txt" type="italics"/>.) Back in the <AutoText key="glidict::GUI.Gather"/> panel of the Librarian Interface, locate the new file in the <b>Workspace</b> tree, and drag it into the collection, adding it to the <AutoText text="12"/> folder.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3709,5 +3734,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="sc23">Open up the file <Path>xml &rarr; 23 &rarr; 23__2.item</Path> and have a look at the XML. This is <AutoText text="Number"/> <AutoText text="2" type="italics"/> of the newspaper titled <AutoText text="Matariki 1881" type="italics"/>. The contents of this document have been grouped into two sections: <AutoText text="Supplementary Material"/>, which contains an <AutoText text="Abstract"/>, and <AutoText text="Newspaper Pages"/>, which contains the page images (and OCR text). </Text>
+<Text id="sc23">Open up the file <Path>xml &rarr; 23 &rarr; 23__2.item</Path> and have a look at the XML. This is <AutoText text="Number "/> <AutoText text="2" type="italics"/> of the newspaper titled <AutoText text="Matariki 1881" type="italics"/>. The contents of this document have been grouped into two sections: <AutoText text="Supplementary Material"/>, which contains an <AutoText text="Abstract"/>, and <AutoText text="Newspaper Pages"/>, which contains the page images (and OCR text). </Text>
 </NumberedItem>
 <NumberedItem>
@@ -3782,5 +3807,5 @@
 </Title>
 <SampleFiles folder="oai"/>
-<Version initial="2.60" current="2.85"/>
+<Version initial="2.60" current="2.85|3.05"/>
 <Content>
 <Comment>
@@ -3971,5 +3996,5 @@
 </Title>
 <Prerequisite id="simple_image_collection"/>
-<Version initial="2.85" current="2.85"/>
+<Version initial="2.85" current="2.85|3.05"/>
 <Content>
 <Comment>
@@ -4100,5 +4125,5 @@
 </Title>
 <Prerequisite id="GS_OAI_server"/>
-<Version initial="2.60" current="2.85"/>
+<Version initial="2.60" current="2.85|3.05"/>
 <Content>
 <Comment>
@@ -4227,5 +4252,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0759">In your Windows file browser, locate the <Path>archives</Path> folder for the collection you are working with (in <Path>Greenstone &rarr; collect &rarr; &lt;collname&gt; &rarr; archives</Path>). For each document in the collection, Greenstone has generated two files: <Path>docmets.xml</Path>, the core METS description, and <Path>doctxt.xml</Path>, a supporting file. (Note: unless you are connected to the Internet you may be unable to view <Path>doctxt.xml</Path> in your web browser, because it refers to a remote resource.) Depending on the source documents there may be additional files, such as the images used within a web page. One of METS' many features is the ability to reference information in external XML files. Greenstone uses this to tie the content of the document, which is stored in the external XML file <Path>doctxt.xml</Path>, to its hierarchical structure, which is described in the core METS file <Path>docmets.xml</Path>.</Text>
+<Text id="0759">In your Windows file browser, locate the <Path>archives</Path> folder for the collection you are working with (in <Path>Greenstone<MajorVersion number="3">3 &rarr; web &rarr; sites &rarr; localsite</MajorVersion> &rarr; collect &rarr; &lt;collname&gt; &rarr; archives</Path>). For each document in the collection, Greenstone has generated two files: <Path>docmets.xml</Path>, the core METS description, and <Path>doctxt.xml</Path>, a supporting file. (Note: unless you are connected to the Internet you may be unable to view <Path>doctxt.xml</Path> in your web browser, because it refers to a remote resource.) Depending on the source documents there may be additional files, such as the images used within a web page. One of METS' many features is the ability to reference information in external XML files. Greenstone uses this to tie the content of the document, which is stored in the external XML file <Path>doctxt.xml</Path>, to its hierarchical structure, which is described in the core METS file <Path>docmets.xml</Path>.</Text>
 </NumberedItem>
 </Content>