Index: /documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 27120)
+++ /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 27121)
@@ -3449,5 +3449,5 @@
 	&lt;/gsf:switch&gt;
 </Format>
-<Text id="0686b-31a">with this:</Text>
+<Text id="0686b-31a">with this, which can also be copied from the file <Path>titles_tweak_gs3.txt</Path>:</Text>
 <Format>
   &lt;/td&gt;<br />
@@ -3717,5 +3717,5 @@
 1:images/12_3_6_1.gif:text/12_3_6_1.txt
 </Format>
-<Text id="sc16">Note that if there is no text file, you can leave that space blank. You need to add a line for each page in the document. Make sure you increment the page number as well as the image number for each line. (The full text for this file can be copied from <Path>sample_files &rarr; niupepa &rarr; formats &rarr; 12item_text.txt</Path>.)</Text>
+<Text id="sc16">Note that if there is no text file, you can leave that space blank. You need to add a line for each page in the document. Make sure you increment the page number as well as the image number for each line. (The full text for this file can be copied from <Path>sample_files &rarr; niupepa &rarr; formats &rarr; 12_3_6.item</Path>.)</Text>
 </NumberedItem>
 <NumberedItem>
@@ -4273,5 +4273,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0768">In the <AutoText key="glidict::GUI.Gather"/> panel, locate the folder <Path>sample_files &rarr; dspace</Path>. It contains five example items exported from a DSpace institutional repository. Copy them into your collection by dragging them over to the right-hand side of the panel. Cancel out of any dialog offering to add plugins.</Text>
+<Text id="0768">In the <AutoText key="glidict::GUI.Gather"/> panel, locate the folder <Path>sample_files &rarr; dspace</Path>. It contains five example items exported from a DSpace institutional repository. Copy them into your collection by dragging them over to the right-hand side of the panel. Cancel out any dialog offering to add plugins.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -4279,5 +4279,5 @@
 </NumberedItem>
 <Comment>
-<Text id="0770">If you browse by <AutoText key="coredm::_Global:labelTitle_" type="italics"/>, you will find 7 documents listed, though only 5 items were exported from DSpace. Two of the original items had alternative forms in their directory folder. The DSpace plug-in options control what happens in such situations: the default is to treat them as separate Greenstone documents.</Text>
+<Text id="0770">If you browse by <MajorVersion number="2"><AutoText key="coredm::_Global:labelTitle_"/></MajorVersion><MajorVersion number="3"><AutoText key="gs3::metadata_names::Title.buttonname" /></MajorVersion>, you will find 7 documents listed, though only 5 items were exported from DSpace. Two of the original items had alternative forms in their directory folder. The DSpace plug-in options control what happens in such situations: the default is to treat them as separate Greenstone documents.</Text>
 </Comment>
 <Comment>
@@ -4307,5 +4307,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0780">Now select the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel, and select the <MajorVersion number="2"><AutoText text="VList" /></MajorVersion><MajorVersion number="3"><AutoText key="coredm::_Global:labelBrowse_"/></MajorVersion> format statement in the list of assigned format statements. Add the following text before the final <Format>&lt;/td&gt;</Format><MajorVersion number="3"> of the <AutoText text="documentNode"/> template</MajorVersion>:</Text>
+<Text id="0780">Now select the <AutoText key="glidict::CDM.GUI.Formats"/> section of the <AutoText key="glidict::GUI.Format"/> panel, and select the <MajorVersion number="2"><AutoText text="VList" /></MajorVersion><MajorVersion number="3"><AutoText text="browse"/></MajorVersion> format statement in the list of assigned format statements. Add the following text before the final <Format>&lt;/td&gt;</Format><MajorVersion number="3"> of the <AutoText text="documentNode"/> template</MajorVersion>:</Text>
 <Format>
 <MajorVersion number="2">{If}{[ex.equivlink],&lt;br&gt;Also available as:[ex.equivlink]}</MajorVersion>
@@ -4314,5 +4314,8 @@
         <Tab n="1"/>&lt;gsf:metadata name=&quot;equivDocLink&quot;/&gt;<br />
         <Tab n="1"/>&lt;gsf:when test=&quot;exists&quot;&gt;<br />
-	  <Tab n="2"/>&lt;br/&gt;Also available as:&lt;gsf:equivlinkgs3/&gt;<br />
+	  <Tab n="2"/>&lt;br/&gt;Also available as: <br />
+	  <Tab n="2"/>&lt;gsf:metadata name=&quot;equivDocLink&quot;/&gt;<br/>
+	  <Tab n="2"/>&lt;gsf:metadata name=&quot;equivDocIcon&quot;/&gt;<br/>
+	  <Tab n="2"/>&lt;gsf:metadata name=&quot;/equivDocLink&quot;/&gt;<br/>
         <Tab n="1"/>&lt;/gsf:when&gt;<br />
       &lt;/gsf:switch&gt;
@@ -4327,5 +4330,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="0783"><MajorVersion number="2">Leave <AutoText text="VList" /> as the <AutoText key="glidict::CDM.FormatManager.Part"/> and click</MajorVersion><MajorVersion number="3">Click</MajorVersion> <AutoText key="glidict::CDM.FormatManager.Add" type="button"/>. Edit the text in the <AutoText key="glidict::CDM.FormatManager.Editor"/> box. <MajorVersion number="3">Adjust the <AutoText text="documentNode"/> template of this format statement to make reference to <Format>&lt;gsf:equivlinkgs3/&gt;</Format> too, exactly as in the previous step. Then replace</MajorVersion><MajorVersion number="2">Replace</MajorVersion></Text>
+<Text id="0783"><MajorVersion number="2">Leave <AutoText text="VList" /> as the <AutoText key="glidict::CDM.FormatManager.Part"/> and click</MajorVersion><MajorVersion number="3">Click</MajorVersion> <AutoText key="glidict::CDM.FormatManager.Add" type="button"/>. <MajorVersion number="3">Adjust the <AutoText text="documentNode"/> template of this format statement to make reference to <Format>&lt;gsf:equivDocLink/&gt;</Format>  too, exactly as in the previous step. Then replace</MajorVersion><MajorVersion number="2">Edit the text in the <AutoText key="glidict::CDM.FormatManager.Editor"/> box.  Replace</MajorVersion></Text>
 <Format>
 <MajorVersion number="2">{Or}{[dc.Title],[exp.Title],[ex.Title],Untitled}</MajorVersion>
@@ -4342,10 +4345,14 @@
 </Format>
 <MajorVersion number="3">
-<Text id="0783b">Then scroll down to the <AutoText text="classifierNode"/> template for <AutoText text="VList" />s. Here too, locate the same <Format>&lt;gsf:choose-metadata&gt; ... &lt;/gsf:choose-metadata&gt;</Format> format statement as before, but this time replace it with the following:</Text>
-<Format>
-&lt;gsf:metadata name=&quot;Title&quot;/&gt;(&lt;gsf:metadata name=&quot;numleafdocs&quot;/&gt;)
-</Format>
-</MajorVersion>
-<Text id="0784">This will display the number of documents for each bookshelf in the <AutoText key="coredm::_Global:labelContributor_" type="italics"/> classifier.
+<Text id="0783b">Then scroll down to the <AutoText text="classifierNode"/> template for <AutoText text="VList" />s. Here, replace:</Text>
+<Format>
+&lt;gsf:metadata name=&quot;Title&quot;/&gt;
+</Format>
+<Text id="0783c">with</Text>
+<Format>
+&lt;gsf:metadata name=&quot;Title&quot;/&gt; (&lt;gsf:metadata name=&quot;numleafdocs&quot;/&gt;)
+</Format>
+</MajorVersion>
+<Text id="0784">This will display the number of documents for each bookshelf in the <MajorVersion number="2"><AutoText key="coredm::_Global:labelContributor_" type="italics"/></MajorVersion><MajorVersion number="3"><AutoText text="Contributors" type="italics"/></MajorVersion> classifier.
 <MajorVersion number="3">And for individual documents within each bookshelf, it will display the <AutoText text="ex.dc.Title"/>.</MajorVersion></Text>
 </NumberedItem>
@@ -4363,5 +4370,5 @@
 </Title>
 <Prerequisite id="dspace_to_greenstone"/>
-<Version initial="2.60" current="2.85"/>
+<Version initial="2.60" current="2.85|3.05"/>
 <Content>
 <Comment>
@@ -4413,5 +4420,5 @@
 <Text id="gems-1">Editing metadata sets</Text>
 </Title>
-<Version initial="2.70w" current="2.85"/>
+<Version initial="2.70w" current="2.85|3.05"/>
 <Content>
 <Text id="gems-2">GEMS (Greenstone Editor for Metadata Sets) can be used to modify existing metadata sets or create new ones. GEMS is launched from the Librarian Interface when you want to create a new metadata set, or edit an existing one. In this exercise, we run GEMS outside of the Librarian Interface.</Text>
@@ -4421,5 +4428,5 @@
 <NumberedItem>
 <Text id="gems-4">Start the Greenstone Editor for Metadata Sets (GEMS)</Text>
-<Text id="gems-5"><Menu>Start &rarr; All Programs &rarr; Greenstone-2.85 &rarr; Metadata Set Editor (GEMS)</Menu></Text>
+<Text id="gems-5"><MajorVersion number="2"><Menu>Start &rarr; All Programs &rarr; Greenstone-2.85 &rarr; Metadata Set Editor (GEMS)</Menu></MajorVersion><MajorVersion number="3"><Menu>Start &rarr; All Programs &rarr; Greenstone-3.05 &rarr; Greenstone Editor for Metadata Sets (GEMS)</Menu></MajorVersion></Text>
 <Text id="gems-5a">(If you're on Linux, use a terminal to run the <Command>gli/gems.sh</Command> start-up script.) </Text>
 </NumberedItem>