Index: documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 27121)
+++ documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 27122)
@@ -4462,5 +4462,5 @@
 </Title>
 <SampleFiles folder="demo"/>
-<Version initial="2.70w" current="2.85"/>
+<Version initial="2.70w" current="2.85|3.05"/>
 <Content>
 <Text id="indexers-2">Greenstone supports three indexers <b>MG</b>, <b>MGPP</b> and <b>Lucene</b>. </Text>
@@ -4475,7 +4475,7 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="indexers-8">In the <AutoText key="glidict::GUI.Gather"/> panel, click <AutoText key="glidict::Tree.World"/> and click <MajorVersion number="2"><b>Greenstone demo (demo)</b></MajorVersion><MajorVersion number="3"><b>Demo Collection (lucene-jdbm-demo)</b></MajorVersion>, it will show the documents in the <b>Greenstone demo</b> collection. Drag all 11 folders underneath <Path>Greenstone demo (demo)</Path> into the new collection.</Text>
-<Comment>
-<Text id="demo-collection">If you haven't installed the <b>Greenstone demo (demo)</b> collection yet, you can download the <Path>demo.zip</Path> file from the link above, unzip it and put it into the <Path>collect</Path> folder in your Greenstone installation.</Text>
+<Text id="indexers-8">In the <AutoText key="glidict::GUI.Gather"/> panel, click <AutoText key="glidict::Tree.World"/> and click <MajorVersion number="2"><b>Greenstone demo (demo)</b></MajorVersion><MajorVersion number="3"><Path>localsite &rarr; Demo Collection (lucene-jdbm-demo)</Path></MajorVersion>, it will show the documents in the <b>Greenstone demo</b> collection. Drag all 11 folders in the demo folder into the new collection.</Text>
+<Comment>
+<Text id="demo-collection">If you haven't installed the <MajorVersion number="2"><b>Greenstone demo (demo)</b></MajorVersion><MajorVersion number="3"><b>Demo Collection (lucene-jdbm-demo)</b></MajorVersion> collection yet, you can download the <Path>demo.zip</Path> file from the link above, unzip it and put it into the <Path>collect</Path> folder in your Greenstone installation.</Text>
 </Comment>
 </NumberedItem>
@@ -4500,5 +4500,5 @@
 </Heading>
 <NumberedItem>
-<Text id="indexers-15">Lucene provides single letter and multiple letter wildcards and range searching. The query syntax could be quite complicated (for more information please see http://lucene.apache.org/java/docs/queryparsersyntax.html). Here we will learn how to use the wildcards while constructing queries.</Text>
+<Text id="indexers-15">Lucene provides single letter and multiple letter wildcards and range searching. The query syntax could be quite complicated (for more information please see <Link>http://lucene.apache.org/java/docs/queryparsersyntax.html</Link>. Here we will learn how to use the wildcards while constructing queries.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -4518,5 +4518,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="indexers-21">In the <AutoText key="glidict::GUI.Gather"/> panel, drag all the 11 folders from <Path><AutoText key="glidict::Tree.World"/> &rarr; Greenstone demo (demo)</Path> into the new collection. </Text>
+<Text id="indexers-21">In the <AutoText key="glidict::GUI.Gather"/> panel, drag all 11 folders from <AutoText key="glidict::Tree.World"/><Path> &rarr; <MajorVersion number="2">Greenstone demo (demo)</MajorVersion><MajorVersion number="3">localsite &rarr; Demo Collection (lucene-jdbm-demo)</MajorVersion></Path> into the new collection. </Text>
 </NumberedItem>
 <NumberedItem>
@@ -4557,14 +4557,14 @@
 <MajorVersion number="3">
 <NumberedItem>
-<Text id="indexers-26-3">MGPP supports stemming, casefolding and accentfolding. By default, searching in collections built with MGPP indexer is set to <AutoText key="coredm::_preferences:textnostem_"/> and <AutoText key="coredm::_preferences:textmatchcase_"/>. So searching <i>econom</i> will return 0 documents. Searching for <i>fao</i> will return 0 documents whereas searching for <i>FAO</i> will return &mdash; 89 word counts and 11 matched documents.</Text>
-<Text id="indexers-26a-3">Go to the <AutoText text="advanced search form"/> page by clicking the <AutoText text="advanced search form"/> button at the top right corner. You can see that <b>stem</b> is off, which means <AutoText key="coredm::_preferences:textwordends_"/> option is set to <AutoText key="coredm::_preferences:textnostem_"/>. And <b>case</b> (folding) is off too, which means the <AutoText key="coredm::_preferences:textcasediffs_"/> option is set to <AutoText key="coredm::_preferences:textmatchcase_"/>.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="indexers-27-3">Sometimes we may want to ignore word endings while searching so as to match different variations of the term. Change the <AutoText text="stem"/> option from <AutoText text="off"/> to <AutoText text="on"/>. This will change the search settings from the default, which is that the <AutoText key="coredm::_preferences:textnostem_"/> to <AutoText key="coredm::_preferences:textstem_"/>. Now try searching for <i>econom</i> again, 9 documents are found.</Text>
-<Text id="indexers-27a-3">Please note that word endings are determined according to the third-party stemming tables incorporated in Greenstone, not by the user. Thus the searches may not do precisely what is expected, especially when cultural variations or dialects are concerned. Besides, not all languages support stemming, only English and French have stemming at the moment.</Text>
-<Text id="indexers-27b-3">Change the <AutoText text="stem"/> option back to <AutoText text="off"/> (to <AutoText key="coredm::_preferences:textnostem_"/>) to avoid confusion later on.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="indexers-28-3">Sometimes we may want to search for the exact term, that is, differentiate the upper cases from lower cases. In the <AutoText text="advanced search form"/> page, the default settings already insist that upper/lower case must match (case stemming is off). If you want to ignore case when searching, switch <AutoText text="case"/> folding to <AutoText text="on"/> (<AutoText key="coredm::_preferences:textignorecase_"/>). Now try searching for <i>fao</i> and <i>FAO</i> respectively this time. Notice the search results are the same for both this time.</Text>
+<Text id="indexers-26-3">MGPP supports stemming, casefolding and accentfolding. By default, searching in collections built with MGPP indexer is set to <AutoText text="whole word must match"/> and <AutoText text="upper/lower case must match"/>. So searching <i>econom</i> will return 0 documents. Searching for <i>fao</i> will return 0 documents, whereas searching for <i>FAO</i> will return 89 word counts and 11 matched documents.</Text>
+<Text id="indexers-26a-3">Go to the <AutoText text="advanced search"/> page by clicking the <AutoText text="advanced search"/> button at the top right corner. You can see that <b>stem</b> is off, which means the <b>word endings</b> option is set to <AutoText text="whole word must match"/>. And <b>case</b> (folding) is off too, which means the <b>case difference</b> option is set to <AutoText text="upper/lower case must match"/>.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="indexers-27-3">Sometimes we may want to ignore word endings while searching so as to match different variations of the term. Change the <AutoText text="stem"/> option from <AutoText text="off"/> to <AutoText text="on"/>. This will change the search settings from the default, which is that the <AutoText text="whole word must match"/>, to <AutoText text="ignore word endings"/>. Now try searching for <i>econom</i> again, 9 documents are found.</Text>
+<Text id="indexers-27a-3">Please note that word endings are determined according to the third-party stemming tables incorporated in Greenstone, not by the user. Thus the searches may not do precisely what is expected, especially when cultural variations or dialects are concerned. In addition, not all languages support stemming; only English and French have stemming at the moment.</Text>
+<Text id="indexers-27b-3">Change the <AutoText text="stem"/> option back to <AutoText text="off"/> (<AutoText text="whole word must match"/>) to avoid confusion later on.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="indexers-28-3">Sometimes we may want to search for the exact term, that is, differentiate the upper cases from lower cases. In the <AutoText text="advanced search form"/> page, the default settings already insist that upper/lower case must match (case folding is off). If you want to ignore case when searching, switch <AutoText text="case"/> folding to <AutoText text="on"/> (<AutoText text="ignore case differences"/>). Now try searching for <i>fao</i> and <i>FAO</i> respectively. Notice the search results are the same for both this time.</Text>
 </NumberedItem>
 </MajorVersion>
@@ -4573,18 +4573,18 @@
 </Heading>
 <Comment>
-<Text id="mgpp-1">MGPP has several hotkeys for setting the search modes for a query term. These hotkeys explicitly set the <AutoText key="coredm::_preferences:textwordends_"/> option and the <AutoText key="coredm::_preferences:textcasediffs_"/> option for the query being constructed. <MajorVersion number="3">Use them in the plain <AutoText text="text search"/> or <AutoText text="form search"/>.</MajorVersion></Text>
-</Comment>
-<NumberedItem>
-<Text id="mgpp-2"><b>#s</b> and <b>#u</b> are hotkeys for the <AutoText key="coredm::_preferences:textwordends_"/> option. Appending <b>#s</b> to a query term will specifically enable the <AutoText key="coredm::_preferences:textstem_"/> function. For example, <MajorVersion number="3">click on the <AutoText text="Form search"/> button and </MajorVersion>try searching for <i>econom#s</i>. 9 documents are found, which is the same as in step 17.<MajorVersion number="2"> Remember that we have set it back to <AutoText key="coredm::_preferences:textnostem_"/>. This means using hotkeys will override the current preference settings.</MajorVersion></Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="mgpp-3">Appending <b>#u</b> to a query term will explicitly set the current search to <AutoText key="coredm::_preferences:textnostem_"/>. </Text>
-<Text id="mgpp-4">Note that using hotkeys will only affect that query term. That is, hotkeys are used per term. For example, if a query expression contains more than one term, some terms can have hotkeys and others not, and the hotkeys can be different for different terms. This provides a fine-grained control of the query, whereas <MajorVersion number="2">changing settings in the <AutoText key="coredm::_Global:linktextPREFERENCES_"/> page will affect the query as a whole</MajorVersion><MajorVersion number="3">changing the controls for a search field in the <AutoText text="advanced search form"/> page will apply to all the query terms in that field</MajorVersion>.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="mgpp-5">Hotkeys <b>#i</b> and <b>#c</b> control the case sensitivity. Appending <b>#i</b> to a query term will explicitly set the search to <AutoText key="coredm::_preferences:textignorecase_"/> (i.e. case insensitive).<MajorVersion number="3"> For example, search for <i>fao#i</i> returns 11 documents.</MajorVersion></Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="mgpp-6">In contrast, appending <b>#c</b> will specifically turn off the casefolding, that is, <AutoText key="coredm::_preferences:textmatchcase_"/>.<MajorVersion number="2"> For example, search for <i>fao#c</i> returns 0 documents.</MajorVersion></Text>
+<Text id="mgpp-1">MGPP has several hotkeys for setting the search modes for a query term. These hotkeys explicitly set the <MajorVersion number="2"><AutoText key="coredm::_preferences:textwordends_"/></MajorVersion><MajorVersion number="3"><AutoText text="stem"/></MajorVersion> option and the <MajorVersion number="2"><AutoText key="coredm::_preferences:textcasediffs_"/></MajorVersion><MajorVersion number="3"><AutoText text="case"/></MajorVersion> option for the query being constructed. <MajorVersion number="3">Use them in the plain <AutoText text="text search"/> or <AutoText text="form search"/>.</MajorVersion></Text>
+</Comment>
+<NumberedItem>
+<Text id="mgpp-2"><b>#s</b> and <b>#u</b> are hotkeys for the <MajorVersion number="2"><AutoText key="coredm::_preferences:textwordends_"/></MajorVersion><MajorVersion number="3"><AutoText text="stem"/></MajorVersion> option. Appending <b>#s</b> to a query term will specifically enable the <MajorVersion number="2"><AutoText key="coredm::_preferences:textstem_"/></MajorVersion><MajorVersion number="3"><AutoText text="ignore word endings"/></MajorVersion> function. For example, <MajorVersion number="3">click on the <AutoText text="Form search"/> button and </MajorVersion>try searching for <i>econom#s</i>. 9 documents are found, which is the same as in the previous section.<MajorVersion number="2"> Remember that we have set it back to <AutoText key="coredm::_preferences:textnostem_"/>. This means using hotkeys will override the current preference settings.</MajorVersion></Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="mgpp-3">Appending <b>#u</b> to a query term will explicitly set the current search to <MajorVersion number="2"><AutoText key="coredm::_preferences:textnostem_"/></MajorVersion><MajorVersion number="3"><AutoText text="whole word must match"/></MajorVersion>. </Text>
+<Text id="mgpp-4">Note that using hotkeys will only affect that query term. That is, hotkeys are used per term. For example, if a query expression contains more than one term, some terms can have hotkeys and others not, and the hotkeys can be different for different terms. This provides a fine-grained control of the query, whereas <MajorVersion number="2">changing settings in the <AutoText key="coredm::_Global:linktextPREFERENCES_"/> page will affect the query as a whole</MajorVersion><MajorVersion number="3">changing the controls for a search field on the <AutoText text="advanced search"/> page will apply to all the query terms in that field</MajorVersion>.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="mgpp-5">Hotkeys <b>#i</b> and <b>#c</b> control the case sensitivity. Appending <b>#i</b> to a query term will explicitly set the search to <MajorVersion number="2"><AutoText key="coredm::_preferences:textignorecase_"/> (i.e. case insensitive).</MajorVersion><MajorVersion number="3"><AutoText text="ignore case differences"/> (i.e. case insensitive). For example, search for <i>fao#i</i> returns 11 documents.</MajorVersion></Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="mgpp-6">In contrast, appending <b>#c</b> will specifically turn off the casefolding, that is, <MajorVersion number="3"><AutoText text="upper/lower case must match"/>.</MajorVersion><MajorVersion number="2"><AutoText key="coredm::_preferences:textmatchcase_"/>. For example, search for <i>fao#c</i> returns 0 documents.</MajorVersion></Text>
 </NumberedItem>
 <NumberedItem>
@@ -4594,4 +4594,5 @@
 <Text id="quickref-1">A quick reference of the search mode hotkeys in MGPP</Text>
 </Heading>
+<MajorVersion number="2">
 <Comment>
 <Format><AutoText key="coredm::_preferences:textwordends_"/></Format>
@@ -4602,6 +4603,18 @@
 <Format>&nbsp;&nbsp;&nbsp;&nbsp;<b>#c</b>&nbsp;&nbsp;&nbsp;&nbsp;<AutoText key="coredm::_preferences:textmatchcase_"/></Format>
 </Comment>
+</MajorVersion>
+<MajorVersion number="3">
+<Comment>
+<Format><AutoText text="Word endings:"/></Format>
+<Format>&nbsp;&nbsp;&nbsp;&nbsp;<b>#s</b>&nbsp;&nbsp;&nbsp;&nbsp;<AutoText text="ignore word endings"/></Format>
+<Format>&nbsp;&nbsp;&nbsp;&nbsp;<b>#u</b>&nbsp;&nbsp;&nbsp;&nbsp;<AutoText text="whole word must match"/></Format>
+<Format><AutoText text="Case differences:"/></Format>
+<Format>&nbsp;&nbsp;&nbsp;&nbsp;<b>#i</b>&nbsp;&nbsp;&nbsp;&nbsp;<AutoText text="ignore case differences"/></Format>
+<Format>&nbsp;&nbsp;&nbsp;&nbsp;<b>#c</b>&nbsp;&nbsp;&nbsp;&nbsp;<AutoText text="upper/lower case must match"/></Format>
+</Comment>
+</MajorVersion>
 </Content>
 </Tutorial>
+<MajorVersion number="2">
 <Tutorial id="depositor">
 <Title>
@@ -4696,3 +4709,4 @@
 </Content>
 </Tutorial>
+</MajorVersion>
 </TutorialList>