Index: main/trunk/greenstone3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml
===================================================================
--- main/trunk/greenstone3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml	(revision 27135)
+++ main/trunk/greenstone3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml	(revision 27136)
@@ -1,177 +1,90 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <CollectionConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-	<metadataList>
-		<metadata lang="en" name="creator"/>
-		<metadata lang="en" name="maintainer"/>
-		<metadata lang="en" name="public">true</metadata>
-	</metadataList>
-	<displayItemList>
-		<displayItem assigned="true" lang="en" name="description">This is a demonstration collection for the Greenstone3 digital library software. It contains a small subset (11 books) of the Humanitarian and Development Libraries. It is the Greenstone 3 equivalent of the Greenstone 2 demo collection, built with MG.</displayItem>
-		<displayItem assigned="true" lang="en" name="name">MG demo</displayItem>
-		<displayItem assigned="true" lang="ru" name="section:text">ÐÐ»Ð°Ð²Ñ</displayItem>
-		<displayItem assigned="true" lang="en" name="section:text">chapters</displayItem>
-		<displayItem assigned="true" lang="es" name="section:text">capÃ­tulos</displayItem>
-		<displayItem assigned="true" lang="fr" name="section:text">chapitres</displayItem>
-		<displayItem assigned="true" lang="ru" name="document:text">ÐÐŸÐ»ÐœÑÐµ ÐŽÐŸÐºÑÐŒÐµÐœÑÑ</displayItem>
-		<displayItem assigned="true" lang="en" name="document:text">entire documents</displayItem>
-		<displayItem assigned="true" lang="es" name="document:text">documentos enteros</displayItem>
-		<displayItem assigned="true" lang="fr" name="document:text">documents entiers</displayItem>
-		<displayItem assigned="true" lang="ru" name="section:Title">ÐÐ°Ð·Ð²Ð°ÐœÐžÑ ÑÐ°Ð·ÐŽÐµÐ»ÐŸÐ²</displayItem>
-		<displayItem assigned="true" lang="en" name="section:Title">section titles</displayItem>
-		<displayItem assigned="true" lang="es" name="section:Title">tÃ­tulos de las secciones</displayItem>
-		<displayItem assigned="true" lang="fr" name="section:Title">titres des sections</displayItem>
-		<displayItem assigned="true" lang="en" name="text">text</displayItem>
-		<displayItem assigned="true" lang="en" name="ex.Title">Title</displayItem>
-		<displayItem assigned="true" lang="en" name="ex.Source">Source</displayItem>
-	</displayItemList>
-	<format/>
-	<search type="mg">
-		<index name="section:text">
-			<displayItem lang="ru" name="name">ÐÐ»Ð°Ð²Ñ</displayItem>
-			<displayItem lang="en" name="name">chapters</displayItem>
-			<displayItem lang="es" name="name">capÃ­tulos</displayItem>
-			<displayItem lang="fr" name="name">chapitres</displayItem>
-		</index>
-		<index name="document:text">
-			<displayItem lang="ru" name="name">ÐÐŸÐ»ÐœÑÐµ ÐŽÐŸÐºÑÐŒÐµÐœÑÑ</displayItem>
-			<displayItem lang="en" name="name">entire documents</displayItem>
-			<displayItem lang="es" name="name">documentos enteros</displayItem>
-			<displayItem lang="fr" name="name">documents entiers</displayItem>
-		</index>
-		<index name="section:Title">
-			<displayItem lang="ru" name="name">ÐÐ°Ð·Ð²Ð°ÐœÐžÑ ÑÐ°Ð·ÐŽÐµÐ»ÐŸÐ²</displayItem>
-			<displayItem lang="en" name="name">section titles</displayItem>
-			<displayItem lang="es" name="name">tÃ­tulos de las secciones</displayItem>
-			<displayItem lang="fr" name="name">titres des sections</displayItem>
-		</index>
-		<indexOption name=""/>
-		<searchType name="plain"/>
-		<searchType name="simpleform"/>
-		<searchType name="advancedform"/>
-		<format>
-			<gsf:template match="documentNode">
-				<td valign="top">
-					<gsf:link type="document">
-						<gsf:icon type="document"/>
-					</gsf:link>
-				</td>
-				<td>
-					<gsf:switch>
-						<gsf:metadata name="Title" select="ancestors" separator=": "/>
-						<gsf:when test="exists"><gsf:metadata name="Title" select="ancestors" separator=": "/>:</gsf:when>
-					</gsf:switch>
-					<gsf:link type="document">
-						<gsf:metadata name="Title"/>
-					</gsf:link>
-				</td>
-			</gsf:template>
-		</format>
-	</search>
-	<infodb type="gdbm"/>
-	<import>
-		<pluginList>
-			<plugin name="GreenstoneXMLPlugin"/>
-			<plugin name="HTMLPlugin">
-				<option name="-description_tags"/>
-			</plugin>
-			<plugin name="MetadataXMLPlugin"/>
-			<plugin name="ArchivesInfPlugin"/>
-			<plugin name="DirectoryPlugin"/>
-		</pluginList>
-	</import>
-	<browse>
-		<classifier name="List">
-			<option name="-metadata" value="dc.Title"/>
-			<option name="-partition_type_within_level" value="constant_size"/>
-		</classifier>
-		<classifier name="Hierarchy">
-			<option name="-metadata" value="dc.Subject"/>
-			<option name="-sort" value="dc.Title"/>
-		</classifier>
-		<classifier name="List">
-			<option name="-metadata" value="dls.Organization"/>
-			<option name="-sort_leaf_nodes_using" value="dc.Title"/>
-			<option name="-partition_type_within_level" value="constant_size"/>
-			<option name="-bookshelf_type" value="always"/>
-			<option name="-buttonname" value="Organization"/>
-		</classifier>
-		<classifier name="List">
-			<option name="-metadata" value="dls.Keyword"/>
-			<option name="-buttonname" value="Howto"/>
-			<option name="-partition_type_within_level" value="constant_size"/>
-			<format>
-			<gsf:template match="documentNode">
-				<td>
-					<gsf:link type="document">
-						<gsf:metadata name="dls.Keyword"/>
-					</gsf:link>
-				</td>
-			</gsf:template>
-			<gsf:template match="classifierNode">
-				<td>
-					<gsf:link type="classifier">
-						<gsf:metadata name="Title"/>
-					</gsf:link>
-				</td>
-			</gsf:template>
-		</format>
-		</classifier>
-		<format>
-			<gsf:template match="documentNode">
-				<td valign="top">
-					<gsf:link type="document">
-						<gsf:icon type="document"/>
-					</gsf:link>
-				</td>
-				<td valign="top">
-					<gsf:metadata name="srclink"/>
-					<gsf:choose-metadata>
-						<gsf:metadata name="thumbicon"/>
-						<gsf:metadata name="srcicon"/>
-					</gsf:choose-metadata>
-					<gsf:metadata name="/srclink"/>
-				</td>
-				<td valign="top">
-					<gsf:choose-metadata>
-						<gsf:metadata name="dc.Title"/>
-						<gsf:metadata name="exp.Title"/>
-						<gsf:metadata name="Title"/>
-						<gsf:default>Untitled</gsf:default>
-					</gsf:choose-metadata>
-					<gsf:switch>
-						<gsf:metadata name="Source"/>
-						<gsf:when test="exists">
-							<br/>
-							<i>(<gsf:metadata name="Source"/>)</i>
-						</gsf:when>
-					</gsf:switch>
-				</td>
-			</gsf:template>
-			<gsf:template match="classifierNode">
-				<td valign="top">
-					<gsf:link type="classifier">
-						<gsf:icon type="classifier"/>
-					</gsf:link>
-				</td>
-				<td valign="top">
-					<gsf:metadata name="Title"/>
-				</td>
-			</gsf:template>
-			<gsf:template match="classifierNode" mode="horizontal">
-				<gsf:link type="horizontal">
-					<gsf:metadata name="Title"/>
-				</gsf:link>
-			</gsf:template>
-		</format>
-	</browse>
-	<display>
-		<format>
-			<gsf:option name="TOC" value="true"/>
-		</format>
-	</display>
-	<replaceListRef id="gs2-standard"/>
-	<serviceRackList><!-- comment out the following serviceRack if you want to disable OAI for this collection -->
+    <metadataList>
+        <metadata lang="en" name="creator"/>
+        <metadata lang="en" name="maintainer"/>
+        <metadata lang="en" name="public">true</metadata>
+    </metadataList>
+    <displayItemList>
+        <displayItem assigned="true" lang="en" name="description">This is a demonstration collection for the Greenstone3 digital library software. It contains a small subset (11 books) of the Humanitarian and Development Libraries. It is the Greenstone 3 equivalent of the Greenstone 2 demo collection, built with MG.</displayItem>
+		<!--
+        <displayItem assigned="true" lang="en" name="smallicon">gs2mgdemo_sm.gif</displayItem>
+        <displayItem assigned="true" lang="en" name="icon">gs2mgdemo.gif</displayItem>
+		-->
+        <displayItem assigned="true" lang="en" name="name">MG demo</displayItem>
+    </displayItemList>
+    <search type="mg">
+        <index name="section:text">
+            <displayItem lang="ru" name="name">ÐÐ»Ð°Ð²Ñ</displayItem>
+            <displayItem lang="en" name="name">chapters</displayItem>
+            <displayItem lang="es" name="name">capÃ­tulos</displayItem>
+            <displayItem lang="fr" name="name">chapitres</displayItem>
+        </index>
+        <index name="document:text">
+            <displayItem lang="ru" name="name">ÐÐŸÐ»ÐœÑÐµ ÐŽÐŸÐºÑÐŒÐµÐœÑÑ</displayItem>
+            <displayItem lang="en" name="name">entire documents</displayItem>
+            <displayItem lang="es" name="name">documentos enteros</displayItem>
+            <displayItem lang="fr" name="name">documents entiers</displayItem>
+        </index>
+        <index name="section:Title">
+            <displayItem lang="ru" name="name">ÐÐ°Ð·Ð²Ð°ÐœÐžÑ ÑÐ°Ð·ÐŽÐµÐ»ÐŸÐ²</displayItem>
+            <displayItem lang="en" name="name">section titles</displayItem>
+            <displayItem lang="es" name="name">tÃ­tulos de las secciones</displayItem>
+            <displayItem lang="fr" name="name">titres des sections</displayItem>
+        </index>
+        <indexOption>
+            <option name="casefold"/>
+            <option name="stem"/>
+        </indexOption>
+        <searchType name="plain"/>
+        <searchType name="simpleform"/>
+        <searchType name="advancedform"/>
+        <format><gsf:template match="documentNode"><td valign="top"><gsf:link type="document"><gsf:icon type="document"/></gsf:link></td><td><gsf:switch><gsf:metadata name="Title" select="ancestors" separator=": "/><gsf:when test="exists"><gsf:metadata name="Title" select="ancestors" separator=": "/>:</gsf:when></gsf:switch><gsf:link type="document"><gsf:metadata name="Title"/></gsf:link></td></gsf:template></format>
+    </search>
+    <infodb type="gdbm"/>
+    <import>
+        <pluginList>
+            <plugin name="GreenstoneXMLPlugin"/>
+            <plugin name="HTMLPlugin">
+                <option name="-description_tags"/>
+            </plugin>
+            <plugin name="MetadataXMLPlugin"/>
+            <plugin name="ArchivesInfPlugin"/>
+            <plugin name="DirectoryPlugin"/>
+        </pluginList>
+    </import>
+    <browse>
+        <classifier name="List">
+            <option name="-metadata" value="dc.Title"/>
+            <option name="-partition_type_within_level" value="constant_size"/>
+        </classifier>
+        <classifier name="Hierarchy">
+            <option name="-metadata" value="dc.Subject"/>
+            <option name="-sort" value="dc.Title"/>
+        </classifier>
+        <classifier name="List">
+            <option name="-metadata" value="dls.Organization"/>
+            <option name="-sort_leaf_nodes_using" value="dc.Title"/>
+            <option name="-partition_type_within_level" value="constant_size"/>
+            <option name="-bookshelf_type" value="always"/>
+            <option name="-buttonname" value="Organization"/>
+        </classifier>
+        <classifier name="List">
+            <option name="-metadata" value="dls.Keyword"/>
+            <option name="-buttonname" value="Howto"/>
+            <option name="-partition_type_within_level" value="constant_size"/>
+            <format><gsf:template match="documentNode"><td><gsf:link type="document"><gsf:metadata name="dls.Keyword"/></gsf:link></td></gsf:template><gsf:template match="classifierNode"><td><gsf:link type="classifier"><gsf:metadata name="Title"/></gsf:link></td></gsf:template></format>
+        </classifier>
+        <format><gsf:template match="documentNode"><td valign="top"><gsf:link type="document"><gsf:icon type="document"/></gsf:link></td><td valign="top"><gsf:metadata name="srclink"/><gsf:choose-metadata><gsf:metadata name="thumbicon"/><gsf:metadata name="srcicon"/></gsf:choose-metadata><gsf:metadata name="/srclink"/></td><td valign="top"><gsf:choose-metadata><gsf:metadata name="dc.Title"/><gsf:metadata name="exp.Title"/><gsf:metadata name="Title"/><gsf:default>Untitled</gsf:default></gsf:choose-metadata><gsf:switch><gsf:metadata name="Source"/><gsf:when test="exists"><br/><i>(<gsf:metadata name="Source"/>)</i></gsf:when></gsf:switch></td></gsf:template><gsf:template match="classifierNode"><td valign="top"><gsf:link type="classifier"><gsf:icon type="classifier"/></gsf:link></td><td valign="top"><gsf:metadata name="Title"/></td></gsf:template><gsf:template match="classifierNode" mode="horizontal"><gsf:link type="horizontal"><gsf:metadata name="Title"/></gsf:link></gsf:template></format>
+    </browse>
+    <display>
+        <format><gsf:option name="TOC" value="true"/></format>
+    </display>
+    <replaceListRef id="gs2-standard"/>
+		<serviceRackList>
+		<!-- comment out the following serviceRack if you want to disable OAI for this collection -->
 		<serviceRack name="OAIPMH">
-			<ListMetadataFormats><!--What metadata sets to support is collection specific. To support other metadata schema, simply add a metadataFormat element here.
+			<ListMetadataFormats>
+			<!--What metadata sets to support is collection specific. To support other metadata schema, simply add a metadataFormat element here.
 			The support of unqualified Dublin Core metadata set is mendatory in the oai specification.
 			-->
@@ -179,5 +92,6 @@
 					<metadataPrefix>oai_dc</metadataPrefix>
 					<schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
-					<metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace><!--   a custom mapping as this collection doesn't have dc metadata -->
+					<metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
+					<!--   a custom mapping as this collection doesn't have dc metadata -->
 					<mappingList>
 						<mapping>dc:title,dc.Title</mapping>
@@ -188,5 +102,5 @@
 				</metadataFormat>
 			</ListMetadataFormats>
-		</serviceRack>
+		</serviceRack> 
 	</serviceRackList>
 </CollectionConfig>
Index: main/trunk/greenstone3/web/sites/localsite/collect/lucene-jdbm-demo/etc/collectionConfig.xml
===================================================================
--- main/trunk/greenstone3/web/sites/localsite/collect/lucene-jdbm-demo/etc/collectionConfig.xml	(revision 27135)
+++ main/trunk/greenstone3/web/sites/localsite/collect/lucene-jdbm-demo/etc/collectionConfig.xml	(revision 27136)
@@ -1,10 +1,13 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <CollectionConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+
 	<metadataList>
-		<metadata lang="en" name="creator"/>
-		<metadata lang="en" name="maintainer"/>
-		<metadata lang="en" name="public">false</metadata>
+		<metadata lang="en" name="creator"></metadata>
+		<metadata lang="en" name="maintainer"></metadata>
+		<metadata lang="en" name="public">true</metadata>
 	</metadataList>
+
 	<displayItemList>
+		<displayItem assigned="true" lang="en" name="name">Demo Collection</displayItem> 
 		<displayItem assigned="true" lang="en" name="description">
 		  This is a demonstration collection for the Greenstone3 digital library software. 
@@ -13,39 +16,14 @@
 		  Lucene for indexing and JDBM as the database for metadata.
 		</displayItem>
-		<displayItem assigned="true" lang="en" name="name">Demo Collection</displayItem>
-		<displayItem assigned="true" lang="en" name="allfields">all fields</displayItem>
-		<displayItem assigned="true" lang="en" name="text">text</displayItem>
-		<displayItem assigned="true" lang="en" name="dc.Title,Title">titles</displayItem>
-		<displayItem assigned="true" lang="en" name="dc.Subject">subjects</displayItem>
-		<displayItem assigned="true" lang="en" name="dls.Organization">organisations</displayItem>
-		<displayItem assigned="true" lang="en" name="document:text">text</displayItem>
-		<displayItem assigned="true" lang="en" name="document:ex.Title">Title</displayItem>
-		<displayItem assigned="true" lang="en" name="document:ex.Source">Source</displayItem>
-		<displayItem assigned="true" lang="en" name="section">chapter</displayItem>
-		<displayItem assigned="true" lang="en" name="document">book</displayItem>
-		<displayItem assigned="true" lang="en" name="shortDescription">
+		<displayItem lang="en" name="shortDescription">
 		  Demonstration collection containing a few books from the Humanitarian and Development 
 		  Libraries. Uses Lucene and JDBM.
-		</displayItem>
+		</displayItem> 
 	</displayItemList>
-	<format>   <xsl:template name="additionalHeaderContent">
-    <xsl:variable name="httpCollection">
-      <xsl:value-of select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
-    </xsl:variable>
-
-    <link href="{$httpCollection}/style/font_change.css" rel="stylesheet" type="text/css"/>
-  </xsl:template>
-
-<!--
-Define any global format statements here
--->
-  <xsl:template name="additionalHeaderContent">
-    <xsl:variable name="httpCollection">
-      <xsl:value-of select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
-    </xsl:variable>
-    <link href="{$httpCollection}/style/font_change.css" rel="stylesheet" type="text/css"/>
-  </xsl:template>
-
-</format>
+
+	<format>
+	  <!-- Define any global format statements here -->
+	</format>
+
 	<search type="lucene">
 		<level name="section">
@@ -71,34 +49,32 @@
 			<displayItem lang="en" name="name">organisations</displayItem>
 		</index>
-		<indexOption name=""/>
+		<indexOption>
+			<option name="accentfold"/>
+			<option name="casefold"/>
+			<option name="stem"/>
+		</indexOption>
 		<searchType name="plain"/>
 		<searchType name="simpleform"/>
 		<searchType name="advancedform"/>
-		<format>  <xsl:template name="additionalHeaderContent">
-    <xsl:variable name="httpCollection">
-      <xsl:value-of select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
-    </xsl:variable>
-    <link href="{$httpCollection}/style/font_change.css" rel="stylesheet" type="text/css"/>
-  </xsl:template>
-  <gsf:template match="documentNode">
-    <td valign="top">
-      <gsf:link type="document">
-        <gsf:icon type="document"/>
-      </gsf:link>
-    </td>
-    <td>
-      <gsf:link type="document">
-        <gsf:choose-metadata>
-          <gsf:metadata name="dc.Title"/>
-          <gsf:metadata name="exp.Title"/>
-          <gsf:metadata name="ex.dc.Title"/>
-          <gsf:metadata name="Title"/>
-          <gsf:default>Untitled</gsf:default>
-        </gsf:choose-metadata>
-      </gsf:link>
-    </td>
-  </gsf:template>
-
-</format>
+		<format>
+			<gsf:template match="documentNode">
+				<td valign="top">
+					<gsf:link type="document">
+						<gsf:icon type="document"/>
+					</gsf:link>
+				</td>
+				<td>
+					<gsf:link type="document">
+						<gsf:choose-metadata>
+							<gsf:metadata name="dc.Title"/>
+							<gsf:metadata name="exp.Title"/>
+							<gsf:metadata name="ex.dc.Title"/>
+							<gsf:metadata name="Title"/>
+							<gsf:default>Untitled</gsf:default>
+						</gsf:choose-metadata>
+					</gsf:link>
+				</td>
+			</gsf:template>
+		</format>
 	</search>
 	<infodb type="jdbm"/>
@@ -151,83 +127,88 @@
 		</format>
 		</classifier>
-		<format>  <gsf:template match="documentNode">
-    <td valign="top">
-      <gsf:link type="document">
-        <gsf:icon type="document"/>
-      </gsf:link>
-    </td>
-    <td valign="top">
-      <gsf:link type="source">
-        <gsf:choose-metadata>
-          <gsf:metadata name="thumbicon"/>
-          <gsf:metadata name="srcicon"/>
-        </gsf:choose-metadata>
-      </gsf:link>
-    </td>
-    <td valign="top">
-      <gsf:link type="document">
-        <gsf:choose-metadata>
-          <gsf:metadata name="dc.Title"/>
-          <gsf:metadata name="exp.Title"/>
-          <gsf:metadata name="ex.dc.Title"/>
-          <gsf:metadata name="Title"/>
-          <gsf:default>Untitled</gsf:default>
-        </gsf:choose-metadata>
-      </gsf:link>
-      <gsf:switch>
-        <gsf:metadata name="Source"/>
-        <gsf:when test="exists">
-          <br/>
-          <i>(<gsf:metadata name="Source"/>)</i>
-        </gsf:when>
-      </gsf:switch>
-    </td>
-  </gsf:template>
-  <gsf:template match="classifierNode[@classifierStyle = 'VList']">
-    <td valign="top">
-      <gsf:link type="classifier">
-        <gsf:icon type="classifier"/>
-      </gsf:link>
-    </td>
-    <td valign="top">
-      <gsf:choose-metadata>
-        <gsf:metadata name="dc.Title"/>
-        <gsf:metadata name="exp.Title"/>
-        <gsf:metadata name="ex.dc.Title"/>
-        <gsf:metadata name="Title"/>
-        <gsf:default>Untitled</gsf:default>
-      </gsf:choose-metadata>
-      <gsf:switch>
-        <gsf:metadata name="Source"/>
-        <gsf:when test="exists">
-          <br/>
-          <i>(<gsf:metadata name="Source"/>)</i>
-        </gsf:when>
-      </gsf:switch>
-    </td>
-  </gsf:template>
-  <gsf:template match="classifierNode[@classifierStyle = 'HList']">
-    <gsf:link type="classifier">
-      <gsf:metadata name="Title"/>
-    </gsf:link>
-  </gsf:template>
-
-</format>
+		<format>
+			<gsf:template match="documentNode">
+				<td valign="top">
+					<gsf:link type="document">
+						<gsf:icon type="document"/>
+					</gsf:link>
+				</td>
+				<td valign="top">
+					<gsf:link type="source">
+						<gsf:choose-metadata>
+							<gsf:metadata name="thumbicon"/>
+							<gsf:metadata name="srcicon"/>
+						</gsf:choose-metadata>
+					</gsf:link>
+				</td>
+				<td valign="top">
+					<gsf:link type="document">
+						<gsf:choose-metadata>
+							<gsf:metadata name="dc.Title"/>
+							<gsf:metadata name="exp.Title"/>
+							<gsf:metadata name="ex.dc.Title"/>
+							<gsf:metadata name="Title"/>
+							<gsf:default>Untitled</gsf:default>
+						</gsf:choose-metadata>
+					</gsf:link>
+					<gsf:switch>
+						<gsf:metadata name="Source"/>
+						<gsf:when test="exists">
+							<br/>
+							<i>(<gsf:metadata name="Source"/>)</i>
+						</gsf:when>
+					</gsf:switch>
+
+				</td>
+			</gsf:template>
+			<gsf:template match="classifierNode[@classifierStyle = 'VList']">
+				<td valign="top">
+					<gsf:link type="classifier">
+						<gsf:icon type="classifier"/>
+					</gsf:link>
+				</td>
+				<td valign="top">
+					<gsf:choose-metadata>
+						<gsf:metadata name="dc.Title"/>
+						<gsf:metadata name="exp.Title"/>
+						<gsf:metadata name="ex.dc.Title"/>
+						<gsf:metadata name="Title"/>
+						<gsf:default>Untitled</gsf:default>
+					</gsf:choose-metadata>
+					<gsf:switch>
+						<gsf:metadata name="Source"/>
+						<gsf:when test="exists">
+							<br/>
+							<i>(<gsf:metadata name="Source"/>)</i>
+						</gsf:when>
+					</gsf:switch>
+				</td>
+			</gsf:template>
+			<gsf:template match="classifierNode[@classifierStyle = 'HList']">
+				<gsf:link type="classifier">
+					<gsf:metadata name="Title"/>
+				</gsf:link>
+			</gsf:template>
+		</format>
 	</browse>
 	<display>
-		<format>  <gsf:option name="TOC" value="true"/>
-  <gsf:headMetaTags>
-    <gsf:metadata name="dc.Title"/>
-    <gsf:metadata name="dc.Subject"/>
-    <gsf:metadata name="dls.Organization"/>
-  </gsf:headMetaTags>
-
-</format>
+		<format>
+			<gsf:option name="TOC" value="true"/>
+			
+			<gsf:headMetaTags>
+			  <gsf:metadata name="dc.Title"/>
+			  <gsf:metadata name="dc.Subject"/>
+			  <gsf:metadata name="dls.Organization"/>
+			</gsf:headMetaTags>
+
+		</format>
 	</display>
 	<replaceListRef id="gs2-standard"/>
 	<serviceRackList>
-		<serviceRack name="RSSRetrieve"/><!-- comment out the following serviceRack if you want to disable OAI for this collection -->
+	  	<serviceRack name="RSSRetrieve"/>
+		<!-- comment out the following serviceRack if you want to disable OAI for this collection -->
 		<serviceRack name="OAIPMH">
-			<ListMetadataFormats><!--What metadata sets to support is collection specific. To support other metadata schema, simply add a metadataFormat element here.
+			<ListMetadataFormats>
+				<!--What metadata sets to support is collection specific. To support other metadata schema, simply add a metadataFormat element here.
 					The support of unqualified Dublin Core metadata set is mandatory in the oai specification.
 				-->
@@ -235,10 +216,11 @@
 					<metadataPrefix>oai_dc</metadataPrefix>
 					<schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
-					<metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace><!--   a custom mapping as this collection doesn't have dc metadata -->
-					<mappingList>
-						<mapping>dc:title,dc.Title</mapping>
-						<mapping>dc:subject,dc.Subject</mapping>
-						<mapping>dc:language,dc.Language</mapping>
-						<mapping>dc:publisher,dls.Organization</mapping>
+					<metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
+					<!--   a custom mapping as this collection doesn't have dc metadata -->                    
+					<mappingList>						
+                        <mapping>dc:title,dc.Title</mapping>
+                        <mapping>dc:subject,dc.Subject</mapping>
+                        <mapping>dc:language,dc.Language</mapping>
+                        <mapping>dc:publisher,dls.Organization</mapping>                    
 					</mappingList>
 				</metadataFormat>