Index: main/trunk/greenstone2/macros/base.dm
===================================================================
--- main/trunk/greenstone2/macros/base.dm	(revision 27099)
+++ main/trunk/greenstone2/macros/base.dm	(revision 27150)
@@ -423,12 +423,4 @@
 
 
-# RSS link and default RSS icon for embedding in the link
-# RSS icon from http://webneel.com/post/freedownload/web-design/icon-design/25-web-rss-icons
-
-_rssicon_ {<img class="icon" src="_httpimages_/rssicon.png" alt="_collectionname_ RSS feed" title="_collectionname_ RSS feed" onLoad="addDomainToRSSAnchor(this)">}
-
-_rsslink_ {<a id="rss" href="_gwcgi_?site=localhost&amp;a=rss&amp;c=_cgiargc_&amp;l=_cgiargl_&amp;w=_cgiargw_">_rssicon_</a>}
-# e.g. rss link: http://localhost:8283/greenstone/cgi-bin/library.cgi?site=localhost&a=rss&c=demo&l=en&w=utf-8&hostname=localhost:8283
-
 ###########################################################################
 # Metadata formatting stuff
Index: main/trunk/greenstone2/macros/nav_css.dm
===================================================================
--- main/trunk/greenstone2/macros/nav_css.dm	(revision 27099)
+++ main/trunk/greenstone2/macros/nav_css.dm	(revision 27150)
@@ -14,5 +14,5 @@
 #######################################################################
 
-_globallinks_ {_If_("_cgiargu_" ne "1",_homelink_) _helplink_ _preflink__optloginlink_}
+_globallinks_ {_If_("_cgiargu_" ne "1",_homelink_) _helplink_ _preflink__optloginlink_ _optrsslink_}
 _homelink_  {_navtaborig_(_httppagehome_,_linktextHOME_,_textdescrhome_)}
 _helplink_  {_navtaborig_(_httppagehelp_,_linktextHELP_,_textdescrhelp_)}
@@ -36,4 +36,36 @@
       </script>
     )
+}
+
+
+# if a collection should have an rss link,
+# set _optrsslink_ for that collection's global package to contain _rsslink_ 
+_optrsslink_ {}
+
+# RSS link and default RSS icon for embedding in the link
+# RSS icon from http://webneel.com/post/freedownload/web-design/icon-design/25-web-rss-icons
+# e.g. rss link: http://localhost:8283/greenstone/cgi-bin/library.cgi?site=localhost&a=rss&c=demo&l=en&w=utf-8&hostname=localhost:8283
+# And the javascript that's used for appending "&hostname=host:port" to the link to the RSS feed
+# The script is activated on loading the rss icon <img>, since onLoad doesn't work on <a>
+# The rsslink that embeds rssicon are two macros defined in base.dm
+# To use this script, define pagescriptextra macro to contain the domainscript macro
+# Can do so at collectionlevel in a collection's extra.dm (try to add it to package about)
+
+_rssicon_ {<img class="icon" src="_httpimages_/rssicon.png" alt="_collectionname_ RSS feed" title="_collectionname_ RSS feed" onLoad="addDomainToRSSAnchor(this)">}
+
+_rsslink_ {<a id="rss" href="_gwcgi_?site=localhost&amp;a=rss&amp;c=_cgiargc_&amp;l=_cgiargl_&amp;w=_cgiargw_">_rssicon_</a>
+<script type="text/javascript">
+function addDomainToRSSAnchor (imgtag) 
+  \{
+     parent = imgtag.parentNode;
+     if (parent && parent.href) 
+     \{
+        parent.href += "&hostname="+location.hostname;
+	if(location.port) \{
+     	   parent.href += ":"+location.port;
+        \}
+     \}
+  \} 
+</script>
 }
 
Index: main/trunk/greenstone2/macros/style.dm
===================================================================
--- main/trunk/greenstone2/macros/style.dm	(revision 27099)
+++ main/trunk/greenstone2/macros/style.dm	(revision 27150)
@@ -229,23 +229,4 @@
 }
 
-# Javascript that's used for appending "&hostname=host:port" to the link to the RSS feed
-# The script is activated on loading the rss icon <img>, since onLoad doesn't work on <a>
-# The rsslink that embeds rssicon are two macros defined in base.dm
-# To use this script, define pagescriptextra macro to contain the domainscript macro
-# Can do so at collectionlevel in a collection's extra.dm (try to add it to package about)
-
-_rssscript_ {
-  function addDomainToRSSAnchor (imgtag) 
-  \{
-     parent = imgtag.parentNode;
-     if (parent && parent.href) 
-     \{
-        parent.href += "&hostname="+location.hostname;
-	if(location.port) \{
-     	   parent.href += ":"+location.port;    
-        \}
-     \}
-  \} 
-}
 
 # imagescript only used in nav_ns4.dm